ExtensionConfig [runtime.cluster.x-k8s.io/v1alpha1]

Description
ExtensionConfig is the Schema for the ExtensionConfig API.
Type
object

Specification

PropertyTypeDescription
apiVersionstring

APIVersion defines the versioned schema of this representation of an object. Servers should convert recognized schemas to the latest internal value, and may reject unrecognized values. More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#resources

kindstring

Kind is a string value representing the REST resource this object represents. Servers may infer this from the endpoint the client submits requests to. Cannot be updated. In CamelCase. More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#types-kinds

metadataObjectMeta

ObjectMeta is metadata that all persisted resources must have, which includes all objects users must create.

specobject

spec is the desired state of the ExtensionConfig.

statusobject

status is the current state of the ExtensionConfig

.spec

Description
spec is the desired state of the ExtensionConfig.
Type
object
Required
clientConfig
PropertyTypeDescription
clientConfigobject

clientConfig defines how to communicate with the Extension server.

namespaceSelectorobject

namespaceSelector decides whether to call the hook for an object based on whether the namespace for that object matches the selector. Defaults to the empty LabelSelector, which matches all objects.

settingsobject

settings defines key value pairs to be passed to all calls to all supported RuntimeExtensions. Note: Settings can be overridden on the ClusterClass.

.spec.clientConfig

Description
clientConfig defines how to communicate with the Extension server.
Type
object
PropertyTypeDescription
caBundlestring

caBundle is a PEM encoded CA bundle which will be used to validate the Extension server's server certificate.

serviceobject

service is a reference to the Kubernetes service for the Extension server. Note: Exactly one of url or service must be specified.

If the Extension server is running within a cluster, then you should use service.

urlstring

url gives the location of the Extension server, in standard URL form (scheme://host:port/path). Note: Exactly one of url or service must be specified.

The scheme must be "https".

The host should not refer to a service running in the cluster; use the service field instead.

A path is optional, and if present may be any string permissible in a URL. If a path is set it will be used as prefix to the hook-specific path.

Attempting to use a user or basic auth e.g. "user:password@" is not allowed. Fragments ("#...") and query parameters ("?...") are not allowed either.

.spec.clientConfig.service

Description
service is a reference to the Kubernetes service for the Extension server. Note: Exactly one of `url` or `service` must be specified. If the Extension server is running within a cluster, then you should use `service`.
Type
object
Required
namenamespace
PropertyTypeDescription
namestring

name is the name of the service.

namespacestring

namespace is the namespace of the service.

pathstring

path is an optional URL path and if present may be any string permissible in a URL. If a path is set it will be used as prefix to the hook-specific path.

portinteger

port is the port on the service that's hosting the Extension server. Defaults to 443. Port should be a valid port number (1-65535, inclusive).

.spec.namespaceSelector

Description
namespaceSelector decides whether to call the hook for an object based on whether the namespace for that object matches the selector. Defaults to the empty LabelSelector, which matches all objects.
Type
object
PropertyTypeDescription
matchExpressionsarray

matchExpressions is a list of label selector requirements. The requirements are ANDed.

matchLabelsobject

matchLabels is a map of {key,value} pairs. A single {key,value} in the matchLabels map is equivalent to an element of matchExpressions, whose key field is "key", the operator is "In", and the values array contains only "value". The requirements are ANDed.

.spec.namespaceSelector.matchExpressions

Description
matchExpressions is a list of label selector requirements. The requirements are ANDed.
Type
array

.spec.namespaceSelector.matchExpressions[]

Description
A label selector requirement is a selector that contains values, a key, and an operator that relates the key and values.
Type
object
Required
keyoperator
PropertyTypeDescription
keystring

key is the label key that the selector applies to.

operatorstring

operator represents a key's relationship to a set of values. Valid operators are In, NotIn, Exists and DoesNotExist.

valuesarray

values is an array of string values. If the operator is In or NotIn, the values array must be non-empty. If the operator is Exists or DoesNotExist, the values array must be empty. This array is replaced during a strategic merge patch.

.spec.namespaceSelector.matchExpressions[].values

Description
values is an array of string values. If the operator is In or NotIn, the values array must be non-empty. If the operator is Exists or DoesNotExist, the values array must be empty. This array is replaced during a strategic merge patch.
Type
array

.spec.namespaceSelector.matchExpressions[].values[]

Type
string

.spec.namespaceSelector.matchLabels

Description
matchLabels is a map of {key,value} pairs. A single {key,value} in the matchLabels map is equivalent to an element of matchExpressions, whose key field is "key", the operator is "In", and the values array contains only "value". The requirements are ANDed.
Type
object

.spec.settings

Description
settings defines key value pairs to be passed to all calls to all supported RuntimeExtensions. Note: Settings can be overridden on the ClusterClass.
Type
object

.status

Description
status is the current state of the ExtensionConfig
Type
object
PropertyTypeDescription
conditionsarray

conditions define the current service state of the ExtensionConfig.

handlersarray

handlers defines the current ExtensionHandlers supported by an Extension.

v1beta2object

v1beta2 groups all the fields that will be added or modified in ExtensionConfig's status with the V1Beta2 version.

.status.conditions

Description
conditions define the current service state of the ExtensionConfig.
Type
array

.status.conditions[]

Description
Condition defines an observation of a Cluster API resource operational state.
Type
object
Required
lastTransitionTimestatustype
PropertyTypeDescription
lastTransitionTimestring

lastTransitionTime is the last time the condition transitioned from one status to another. This should be when the underlying condition changed. If that is not known, then using the time when the API field changed is acceptable.

messagestring

message is a human readable message indicating details about the transition. This field may be empty.

reasonstring

reason is the reason for the condition's last transition in CamelCase. The specific API may choose whether or not this field is considered a guaranteed API. This field may be empty.

severitystring

severity provides an explicit classification of Reason code, so the users or machines can immediately understand the current situation and act accordingly. The Severity field MUST be set only when Status=False.

statusstring

status of the condition, one of True, False, Unknown.

typestring

type of condition in CamelCase or in foo.example.com/CamelCase. Many .condition.type values are consistent across resources like Available, but because arbitrary conditions can be useful (see .node.status.conditions), the ability to deconflict is important.

.status.handlers

Description
handlers defines the current ExtensionHandlers supported by an Extension.
Type
array

.status.handlers[]

Description
ExtensionHandler specifies the details of a handler for a particular runtime hook registered by an Extension server.
Type
object
Required
namerequestHook
PropertyTypeDescription
failurePolicystring

failurePolicy defines how failures in calls to the ExtensionHandler should be handled by a client. Defaults to Fail if not set.

namestring

name is the unique name of the ExtensionHandler.

requestHookobject

requestHook defines the versioned runtime hook which this ExtensionHandler serves.

timeoutSecondsinteger

timeoutSeconds defines the timeout duration for client calls to the ExtensionHandler. Defaults to 10 seconds if not set.

.status.handlers[].requestHook

Description
requestHook defines the versioned runtime hook which this ExtensionHandler serves.
Type
object
Required
apiVersionhook
PropertyTypeDescription
apiVersionstring

apiVersion is the group and version of the Hook.

hookstring

hook is the name of the hook.

.status.v1beta2

Description
v1beta2 groups all the fields that will be added or modified in ExtensionConfig's status with the V1Beta2 version.
Type
object
PropertyTypeDescription
conditionsarray

conditions represents the observations of a ExtensionConfig's current state. Known condition types are Discovered, Paused.

.status.v1beta2.conditions

Description
conditions represents the observations of a ExtensionConfig's current state. Known condition types are Discovered, Paused.
Type
array

.status.v1beta2.conditions[]

Description
Condition contains details for one aspect of the current state of this API Resource.
Type
object
Required
lastTransitionTimemessagereasonstatustype
PropertyTypeDescription
lastTransitionTimestring

lastTransitionTime is the last time the condition transitioned from one status to another. This should be when the underlying condition changed. If that is not known, then using the time when the API field changed is acceptable.

messagestring

message is a human readable message indicating details about the transition. This may be an empty string.

observedGenerationinteger

observedGeneration represents the .metadata.generation that the condition was set based upon. For instance, if .metadata.generation is currently 12, but the .status.conditions[x].observedGeneration is 9, the condition is out of date with respect to the current state of the instance.

reasonstring

reason contains a programmatic identifier indicating the reason for the condition's last transition. Producers of specific condition types may define expected values and meanings for this field, and whether the values are considered a guaranteed API. The value should be a CamelCase string. This field may not be empty.

statusstring

status of the condition, one of True, False, Unknown.

typestring

type of condition in CamelCase or in foo.example.com/CamelCase.

API Endpoints

The following API endpoints are available:

  • /apis/runtime.cluster.x-k8s.io/v1alpha1/namespaces/{namespace}/extensionconfigs
    • DELETE: delete collection of ExtensionConfig
    • GET: list objects of kind ExtensionConfig
    • POST: create a new ExtensionConfig
  • /apis/runtime.cluster.x-k8s.io/v1alpha1/namespaces/{namespace}/extensionconfigs/{name}
    • DELETE: delete the specified ExtensionConfig
    • GET: read the specified ExtensionConfig
    • PATCH: partially update the specified ExtensionConfig
    • PUT: replace the specified ExtensionConfig
  • /apis/runtime.cluster.x-k8s.io/v1alpha1/namespaces/{namespace}/extensionconfigs/{name}/status
    • GET: read status of the specified ExtensionConfig
    • PATCH: partially update status of the specified ExtensionConfig
    • PUT: replace status of the specified ExtensionConfig

/apis/runtime.cluster.x-k8s.io/v1alpha1/namespaces/{namespace}/extensionconfigs

HTTP method
DELETE
Description
delete collection of ExtensionConfig
HTTP responses
HTTP codeResponse body
200 - OKStatus schema
401 - UnauthorizedEmpty
HTTP method
GET
Description
list objects of kind ExtensionConfig
HTTP responses
HTTP codeResponse body
200 - OKExtensionConfigList schema
401 - UnauthorizedEmpty
HTTP method
POST
Description
create a new ExtensionConfig
Query parameters
ParameterTypeDescription
dryRunstringWhen present, indicates that modifications should not be persisted. An invalid or unrecognized dryRun directive will result in an error response and no further processing of the request. Valid values are: - All: all dry run stages will be processed
fieldValidationstringfieldValidation instructs the server on how to handle objects in the request (POST/PUT/PATCH) containing unknown or duplicate fields. Valid values are: - Ignore: This will ignore any unknown fields that are silently dropped from the object, and will ignore all but the last duplicate field that the decoder encounters. This is the default behavior prior to v1.23. - Warn: This will send a warning via the standard warning response header for each unknown field that is dropped from the object, and for each duplicate field that is encountered. The request will still succeed if there are no other errors, and will only persist the last of any duplicate fields. This is the default in v1.23+ - Strict: This will fail the request with a BadRequest error if any unknown fields would be dropped from the object, or if any duplicate fields are present. The error returned from the server will contain all unknown and duplicate fields encountered.
Body parameters
ParameterTypeDescription
bodyExtensionConfig schemaapplication/json formatted
HTTP responses
HTTP codeResponse body
200 - OKExtensionConfig schema
201 - CreatedExtensionConfig schema
202 - AcceptedExtensionConfig schema
401 - UnauthorizedEmpty

/apis/runtime.cluster.x-k8s.io/v1alpha1/namespaces/{namespace}/extensionconfigs/{name}

HTTP method
DELETE
Description
delete the specified ExtensionConfig
Query parameters
ParameterTypeDescription
dryRunstringWhen present, indicates that modifications should not be persisted. An invalid or unrecognized dryRun directive will result in an error response and no further processing of the request. Valid values are: - All: all dry run stages will be processed
HTTP responses
HTTP codeResponse body
200 - OKStatus schema
202 - AcceptedStatus schema
401 - UnauthorizedEmpty
HTTP method
GET
Description
read the specified ExtensionConfig
HTTP responses
HTTP codeResponse body
200 - OKExtensionConfig schema
401 - UnauthorizedEmpty
HTTP method
PATCH
Description
partially update the specified ExtensionConfig
Query parameters
ParameterTypeDescription
dryRunstringWhen present, indicates that modifications should not be persisted. An invalid or unrecognized dryRun directive will result in an error response and no further processing of the request. Valid values are: - All: all dry run stages will be processed
fieldValidationstringfieldValidation instructs the server on how to handle objects in the request (POST/PUT/PATCH) containing unknown or duplicate fields. Valid values are: - Ignore: This will ignore any unknown fields that are silently dropped from the object, and will ignore all but the last duplicate field that the decoder encounters. This is the default behavior prior to v1.23. - Warn: This will send a warning via the standard warning response header for each unknown field that is dropped from the object, and for each duplicate field that is encountered. The request will still succeed if there are no other errors, and will only persist the last of any duplicate fields. This is the default in v1.23+ - Strict: This will fail the request with a BadRequest error if any unknown fields would be dropped from the object, or if any duplicate fields are present. The error returned from the server will contain all unknown and duplicate fields encountered.
HTTP responses
HTTP codeResponse body
200 - OKExtensionConfig schema
401 - UnauthorizedEmpty
HTTP method
PUT
Description
replace the specified ExtensionConfig
Query parameters
ParameterTypeDescription
dryRunstringWhen present, indicates that modifications should not be persisted. An invalid or unrecognized dryRun directive will result in an error response and no further processing of the request. Valid values are: - All: all dry run stages will be processed
fieldValidationstringfieldValidation instructs the server on how to handle objects in the request (POST/PUT/PATCH) containing unknown or duplicate fields. Valid values are: - Ignore: This will ignore any unknown fields that are silently dropped from the object, and will ignore all but the last duplicate field that the decoder encounters. This is the default behavior prior to v1.23. - Warn: This will send a warning via the standard warning response header for each unknown field that is dropped from the object, and for each duplicate field that is encountered. The request will still succeed if there are no other errors, and will only persist the last of any duplicate fields. This is the default in v1.23+ - Strict: This will fail the request with a BadRequest error if any unknown fields would be dropped from the object, or if any duplicate fields are present. The error returned from the server will contain all unknown and duplicate fields encountered.
Body parameters
ParameterTypeDescription
bodyExtensionConfig schemaapplication/json formatted
HTTP responses
HTTP codeResponse body
200 - OKExtensionConfig schema
201 - CreatedExtensionConfig schema
401 - UnauthorizedEmpty

/apis/runtime.cluster.x-k8s.io/v1alpha1/namespaces/{namespace}/extensionconfigs/{name}/status

HTTP method
GET
Description
read status of the specified ExtensionConfig
HTTP responses
HTTP codeResponse body
200 - OKExtensionConfig schema
401 - UnauthorizedEmpty
HTTP method
PATCH
Description
partially update status of the specified ExtensionConfig
Query parameters
ParameterTypeDescription
dryRunstringWhen present, indicates that modifications should not be persisted. An invalid or unrecognized dryRun directive will result in an error response and no further processing of the request. Valid values are: - All: all dry run stages will be processed
fieldValidationstringfieldValidation instructs the server on how to handle objects in the request (POST/PUT/PATCH) containing unknown or duplicate fields. Valid values are: - Ignore: This will ignore any unknown fields that are silently dropped from the object, and will ignore all but the last duplicate field that the decoder encounters. This is the default behavior prior to v1.23. - Warn: This will send a warning via the standard warning response header for each unknown field that is dropped from the object, and for each duplicate field that is encountered. The request will still succeed if there are no other errors, and will only persist the last of any duplicate fields. This is the default in v1.23+ - Strict: This will fail the request with a BadRequest error if any unknown fields would be dropped from the object, or if any duplicate fields are present. The error returned from the server will contain all unknown and duplicate fields encountered.
HTTP responses
HTTP codeResponse body
200 - OKExtensionConfig schema
401 - UnauthorizedEmpty
HTTP method
PUT
Description
replace status of the specified ExtensionConfig
Query parameters
ParameterTypeDescription
dryRunstringWhen present, indicates that modifications should not be persisted. An invalid or unrecognized dryRun directive will result in an error response and no further processing of the request. Valid values are: - All: all dry run stages will be processed
fieldValidationstringfieldValidation instructs the server on how to handle objects in the request (POST/PUT/PATCH) containing unknown or duplicate fields. Valid values are: - Ignore: This will ignore any unknown fields that are silently dropped from the object, and will ignore all but the last duplicate field that the decoder encounters. This is the default behavior prior to v1.23. - Warn: This will send a warning via the standard warning response header for each unknown field that is dropped from the object, and for each duplicate field that is encountered. The request will still succeed if there are no other errors, and will only persist the last of any duplicate fields. This is the default in v1.23+ - Strict: This will fail the request with a BadRequest error if any unknown fields would be dropped from the object, or if any duplicate fields are present. The error returned from the server will contain all unknown and duplicate fields encountered.
Body parameters
ParameterTypeDescription
bodyExtensionConfig schemaapplication/json formatted
HTTP responses
HTTP codeResponse body
200 - OKExtensionConfig schema
201 - CreatedExtensionConfig schema
401 - UnauthorizedEmpty